package jat;

import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.List;
import java.awt.event.ActionEvent;
import javax.swing.JPasswordField;

public class LoginComponent extends JPanel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private JLabel lblLoginName;
	private JLabel lblPassword;
	private JTextField txtLoginName;
	private JPasswordField txtPassword;
	private JPanel panel;
	private JButton btnLogin;
	private JButton btnLogout;

	private List<LoginListener> listeners = new ArrayList<>();
	
	/**
	 * Create the panel.
	 */
	public LoginComponent() {

		initialize();
	}
	private void initialize() {
		GridBagLayout gridBagLayout = new GridBagLayout();
		gridBagLayout.columnWidths = new int[]{0, 0, 0};
		gridBagLayout.rowHeights = new int[]{0, 0, 0, 0};
		gridBagLayout.columnWeights = new double[]{1.0, 1.0, Double.MIN_VALUE};
		gridBagLayout.rowWeights = new double[]{0.0, 0.0, 1.0, Double.MIN_VALUE};
		setLayout(gridBagLayout);
		GridBagConstraints gbc_lblLoginName = new GridBagConstraints();
		gbc_lblLoginName.anchor = GridBagConstraints.EAST;
		gbc_lblLoginName.insets = new Insets(0, 0, 5, 5);
		gbc_lblLoginName.gridx = 0;
		gbc_lblLoginName.gridy = 0;
		add(getLblLoginName(), gbc_lblLoginName);
		GridBagConstraints gbc_txtLoginName = new GridBagConstraints();
		gbc_txtLoginName.insets = new Insets(0, 0, 5, 0);
		gbc_txtLoginName.fill = GridBagConstraints.HORIZONTAL;
		gbc_txtLoginName.gridx = 1;
		gbc_txtLoginName.gridy = 0;
		add(getTxtLoginName(), gbc_txtLoginName);
		GridBagConstraints gbc_lblPassword = new GridBagConstraints();
		gbc_lblPassword.anchor = GridBagConstraints.EAST;
		gbc_lblPassword.insets = new Insets(0, 0, 5, 5);
		gbc_lblPassword.gridx = 0;
		gbc_lblPassword.gridy = 1;
		add(getLblPassword(), gbc_lblPassword);
		GridBagConstraints gbc_txtPassword = new GridBagConstraints();
		gbc_txtPassword.insets = new Insets(0, 0, 5, 0);
		gbc_txtPassword.fill = GridBagConstraints.HORIZONTAL;
		gbc_txtPassword.gridx = 1;
		gbc_txtPassword.gridy = 1;
		add(getTxtPassword(), gbc_txtPassword);
		GridBagConstraints gbc_panel = new GridBagConstraints();
		gbc_panel.gridwidth = 2;
		gbc_panel.insets = new Insets(0, 0, 0, 5);
		gbc_panel.fill = GridBagConstraints.BOTH;
		gbc_panel.gridx = 0;
		gbc_panel.gridy = 2;
		add(getPanel(), gbc_panel);
	}

	private JLabel getLblLoginName() {
		if (lblLoginName == null) {
			lblLoginName = new JLabel("Login Name");
		}
		return lblLoginName;
	}
	private JLabel getLblPassword() {
		if (lblPassword == null) {
			lblPassword = new JLabel("Password");
		}
		return lblPassword;
	}
	private JTextField getTxtLoginName() {
		if (txtLoginName == null) {
			txtLoginName = new JTextField();
			txtLoginName.setText("GodOfGoodness");
			txtLoginName.setColumns(10);
		}
		return txtLoginName;
	}
	private JPasswordField getTxtPassword() {
		if (txtPassword == null) {
			txtPassword = new JPasswordField();
			txtPassword.setText("hellishell");
			txtPassword.setColumns(10);
		}
		return txtPassword;
	}
	private JPanel getPanel() {
		if (panel == null) {
			panel = new JPanel();
			panel.add(getBtnLogin());
			panel.add(getBtnLogout());
		}
		return panel;
	}
	private JButton getBtnLogin() {
		if (btnLogin == null) {
			btnLogin = new JButton("Login");
			btnLogin.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if(getTxtLoginName().getText().startsWith("God") &&
							new String(getTxtPassword().getPassword()).contains("hell")){
						login();
					}
				}
			});
		}
		return btnLogin;
	}
	private JButton getBtnLogout() {
		if (btnLogout == null) {
			btnLogout = new JButton("Logout");
			btnLogout.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					logout();
				}
			});
			btnLogout.setEnabled(false);
		}
		return btnLogout;
	}
	
	public String getLoginName(){
		return getTxtLoginName().getText();
	}
	
	private void login(){
		getBtnLogin().setEnabled(false);
		getBtnLogout().setEnabled(true);
		fireLogin();
	}

	public void logout(){
		getBtnLogin().setEnabled(true);
		getBtnLogout().setEnabled(false);
		fireLogout();
	}
	
	public void addLoginListener(LoginListener listener){
		listeners.add(listener);
	}

	public void removeLoginListener(LoginListener listener){
		listeners.remove(listener);
	}
	
	private void fireLogin(){
		LoginEvent event = new LoginEvent(this);
		for (LoginListener loginListener : listeners) {
			loginListener.login(event);
		}
	}

	private void fireLogout(){
		LoginEvent event = new LoginEvent(this);
		for (LoginListener loginListener : listeners) {
			loginListener.logout(event);
		}
	}
}
