package jat;

import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import javax.swing.JLabel;
import java.awt.Insets;

public class MainWindow extends JFrame {

	private JPanel contentPane;
	private LoginComponent loginComponent;
	private JLabel lblCountDown;
	private JLabel lblCountDownValue;
	private JPanel panel;
	private CountDown countDown;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					MainWindow frame = new MainWindow();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public MainWindow() {
		initialize();
	}
	private void initialize() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		GridBagLayout gblContentPane = new GridBagLayout();
		gblContentPane.columnWidths = new int[]{0, 0, 0, 0};
		gblContentPane.rowHeights = new int[]{0, 0, 0};
		gblContentPane.columnWeights = new double[]{1.0, 0.0, 1.0, Double.MIN_VALUE};
		gblContentPane.rowWeights = new double[]{1.0, 1.0, Double.MIN_VALUE};
		contentPane.setLayout(gblContentPane);
		GridBagConstraints gbc_lblCountDown = new GridBagConstraints();
		gbc_lblCountDown.insets = new Insets(0, 0, 5, 5);
		gbc_lblCountDown.gridx = 0;
		gbc_lblCountDown.gridy = 0;
		contentPane.add(getLblCountDown(), gbc_lblCountDown);
		GridBagConstraints gbc_lblCountDownValue = new GridBagConstraints();
		gbc_lblCountDownValue.insets = new Insets(0, 0, 5, 5);
		gbc_lblCountDownValue.gridx = 1;
		gbc_lblCountDownValue.gridy = 0;
		contentPane.add(getLblCountDownValue(), gbc_lblCountDownValue);
		GridBagConstraints gbc_loginComponent = new GridBagConstraints();
		gbc_loginComponent.insets = new Insets(0, 0, 5, 0);
		gbc_loginComponent.fill = GridBagConstraints.BOTH;
		gbc_loginComponent.gridx = 2;
		gbc_loginComponent.gridy = 0;
		contentPane.add(getLoginComponent(), gbc_loginComponent);
		GridBagConstraints gbc_panel = new GridBagConstraints();
		gbc_panel.gridwidth = 3;
		gbc_panel.insets = new Insets(0, 0, 0, 5);
		gbc_panel.fill = GridBagConstraints.BOTH;
		gbc_panel.gridx = 0;
		gbc_panel.gridy = 1;
		contentPane.add(getPanel(), gbc_panel);
	}

	private LoginComponent getLoginComponent() {
		if (loginComponent == null) {
			loginComponent = new LoginComponent();
			loginComponent.addLoginListener(new LoginListener() {
				@Override
				public void logout(LoginEvent e) {
					getCountDown().stop();
				}

				@Override
				public void login(LoginEvent e) {
					getCountDown().start();
				}
			});
		}
		return loginComponent;
	}
	private JLabel getLblCountDown() {
		if (lblCountDown == null) {
			lblCountDown = new JLabel("Odpocet");
		}
		return lblCountDown;
	}
	private JLabel getLblCountDownValue() {
		if (lblCountDownValue == null) {
			lblCountDownValue = new JLabel("--");
		}
		return lblCountDownValue;
	}
	private JPanel getPanel() {
		if (panel == null) {
			panel = new JPanel();
		}
		return panel;
	}
	/**
	 * @wbp.nonvisual location=52,347
	 */
	private CountDown getCountDown() {
		if (countDown == null) {
			countDown = new CountDown();
			countDown.setStartValue(5);
			countDown.addCountDownListener(new CountDownListener() {
				public void timeOut(CountDownEvent e) {
					getLoginComponent().logout();
				}
				public void valueChanged(CountDownEvent e) {
					getLblCountDownValue().setText(Integer.toString(getCountDown().getValue()));
				}
			});
		}
		return countDown;
	}
}
